# Zaawansowane funkcje programu amaroK

## Skróty klawiszowe

&amarok-mianownik; tak jak większość programów, wykorzystuje skróty klawiszowe; poniżej znajduje się lista tych skrótów i opis ich działania. Aby skonfigurować skróty globalne, wystarczy kliknąć prawym przyciskiem myszy na oknie odtwarzacza i wybrać polecenie Konfiguracja skrótów globalnych.... Podobnie postępujemy chcąc ustalić skróty &amarok-dopelniacz;, tyle, że po kliknięciu wybieramy polecenie Konfiguracja skrótów...

Możesz przyporządkować swoim klawiszom multimedialnym skróty &amarok-dopelniacz;. W ten sposób zamienisz swoją klawiaturę w centrum sterowania programu &amarok-mianownik;.

Skróty globalne:

Kombinacja klawiszy | Działanie
--- | ---
WinX | Odtwarzaj
WinC | Pauza
WinV | Stop
WinB | Następny utwór
WinZ | Poprzedni utwór
WinKP_Add | Podgłośnij
WinKP_Subtract | Przycisz
WinShiftKP_Add | Wyszukaj do przodu
WinShiftKP_Subtract | Wyszukaj do tyłu
WinA | Dodaje multimedia
WinP | Przełącz listę odtwarzania
WinO | Pokaż OSD
WinM | Wycisz

Skróty programu &amarok-mianownik;:

Kombinacja klawiszy | Działanie
--- | ---
CtrlC | Kopiuj
CtrlKP_Enter | Idź do bieżącego utworu
CtrlD | Kolejkuj wybrane utwory
CtrlQ | Zakończ
CtrlShiftZ | Przywróć
CtrlS | Zapisz listę odtwarzania jako...
CtrlA | Zaznacz wszystko
CtrlM | Pokaż pasek menu
CtrlH | Tasuj
CtrlZ | Cofnij

Skróty przeglądarki listy odtwarzania:

Kombinacja klawiszy | Działanie
--- | ---
Spacja | Wczytaj listę odtwarzania
F2 | Zmień nazwę listy odtwarzania
Backspace | Usuń listę odtwarzania

## Interfejs DCOP

Interfejs DCOP umożliwia łatwe zarządzanie programem amaroK, za pomocą samodzielnie stworzonych skryptów.

Interfejs DCOP programu amaroK posiada wiele standardowych funkcji, występujących również w innych programach KDE. Sekcja ta jest podzielona na sześć tabel i opisuje funkcje interfejsu DCOP odpowiedzialne za: kolekcję utworów, przeglądarki kontekstowej, odtwarzacz, listę odtwarzania, przegladarkę list odtwarzania oraz skrypty. Przykładowe wywołanie funkcji dcop pause będzie miało następującą postać:

&percnt;dcop amarok player pause

### dcop amarok collection

Funkcja DCOP | Działanie
--- | ---
int totalAlbums() | Zwraca całkowitą liczbę albumów w Twojej kolekcji.
int totalArtists() | Zwraca całkowitą liczbę wykonawców w Twojej kolekcji.
int totalCompilations() | Zwraca całkowitą liczbę kompilacji w Twojej kolekcji.
int totalGenres() | Zwraca całkowitą liczbę gatunków muzycznych w Twojej kolekcji.
int totalTracks() | Zwraca całkowitą liczbę utworów w Twojej kolekcji.
query | Wysyła zapytanie do bazy danych poprzez SQL.
QStringList similarArtists( int artists ) | Zwraca podobnych wykonawców dla bieżących utworów. Zmienna artists to górny limit liczny zwróconych wyników.
void migrateFile( QString oldURL, QString newURL ) | Przesuwa plik z kolekcji, nie resetuje statystyk.
void scanCollection() | Przeszukuje kolekcję.
void scanCollectionChanges() | Przeszukuje kolekcję tylko w poszukiwaniu zmian.

### dcop amarok contextbrowser

Funkcja DCOP | Działanie
--- | ---
void showCurrentTrack() | Pokazuje bieżący utwór w przeglądarce kontekstowej.
showLyrics | Pokazuje słowa piosenki w przeglądarce kontekstowej.
showWiki | Pokazuje kartę wikipedii w przeglądarce kontekstowej.

### dcop amarok player

Funkcja DCOP | Działanie
--- | ---
bool dynamicModeStatus() | Zwraca status trybu dynamicznego (true dla włączonego).
bool equalizerEnabled() | Zwraca status korektora.
bool isPlaying() | Zwraca wartość true, jeżeli coś jest w danej chwili odtwarzane.
bool randomModeStatus() | Zwraca status trybu losowego (true dla włączonego).
bool repeatPlaylistStatus() | Zwraca true, jeżeli powtarzanie listy odtwarzania jest włączone, false w przeciwnym wypadku.
bool repeatTrackStatus() | Zwraca true, jeżeli powtarzanie utworu jest włączone, false w przeciwnym wypadku.
int getVolume() | Zwraca poziom głośności w przedziale 0-100%
int sampleRate() | Zwraca częstotliwość próbkowania aktualnie odtwarzanego utworu.
int score() | Zwraca notowania aktualnie odtwarzanego utworu.
int status() | Zwraca status odtwarzania: 0 - zatrzymany, 1 - pauza, 2 - odtwarzanie
int trackCurrentTime() | Zwraca obecną pozycję w utworze w sekundach.
int trackPlayCounter() | Zwraca ilość odtworzeń bieżącego utworu.
int trackTotalTime() | Zwraca całkowitą długość utworu w sekundach.
album | Zwraca nazwę albumu,z którego pochodzi aktualnie odtwarzany utwór.
QString artist() | Zwraca wykonawcę aktualnie odtwarzanego utworu.
QString bitrate() | Zwraca szybkość transmisji (bitrate) aktualnie odtwarzanego utworu (w kbps).
QString comment() | Zwraca komentarz na temat aktualnie odtwarzanego utworu.
QString coverImage() | Zwraca adres URL do obrazu okładki aktualnie odtwarzanego utworu.
QString currentTime() | Zwraca bieżącą pozycję (mm:ss) w aktualnie odtwarzanym utworze.
QString encodedURL() | Zwraca zakodowany adres URL aktualnie odtwarzanego utworu.
QString engine() | Zwraca informację o bieżącym silniku audio.
QString genre() | Zwraca informację o gatunku muzyki, do której należy aktualnie odtwarzany utwór.
QString lyrics() | Zwraca słowa aktualnie odtwarzanego utworu.
QString lyricsByPath( QString path ) | Zwraca słowa piosenki określonej zmienną path.
QString nowPlaying() | Zwraca tytuł aktualnie odtwarzanego medium.
QString path() | Zwraca niezakodowaną ścieżkę dostępu do aktualnie odtwarzanego utworu.
QString setContextStyle( QString ) | Ustawia styl CSS przeglądarki kontekstowej.
QString title() | Zwraca tytuł aktualnie odtwarzanego utworu.
QString totalTime() | Zwraca całkowitą długość aktualnie odtwarzanego utworu.
QString track() | Zwraca numer utworu.
QString type() | Zwraca typ pliku.
QString year() | Zwraca rok powstania aktualnie odtwarzanego utworu.
void configEqualizer() | Włącza i wyłącza okno konfiguracji korektora.
void enableDynamicMode(bool enable) | Włącza lub wyłącza tryb dynamiczny
void enableOSD(bool enable) | Włącz lub wyłącza wyświetlanie-na-ekranie (OSD)
void enableRandomMode(bool enable) | Włącza lub wyłącza tryb dynamiczny.
void enableRepeatPlaylist(bool enable) | Włącza lub wyłącza powtarzanie listy odtwarzania.
void enableRepeatTrack(bool enable) | Włącza lub wyłącza powtarzanie utworu.
void mediaDeviceMount() | Ustawia polecenie używane do montowania urządzenia mediów.
void mediaDeviceUmount() | Ustawia polecenie używane do odmontowania urządzenia mediów.
void mute() | Włącza lub wyłącza wyciszenie.
void next() | Analogicznie do wciśnięcia przycisku "Następny".
void pause() | Analogicznie do wciśnięcia przycisku "Pauza".
void play() | Analogicznie do wciśnięcia przycisku "Odtwarzaj".
void playPause() | Przełącza między odtwarzaniem, a pauzą.
void prev() | Analogicznie do wciśnięcia przycisku "Poprzedni".
void queueForTransfer( KURL url ) | Dodaje do kolejki przenoszenia na urządzenie mediów.
void seek(int s) | Przewija do pozycji s w sekundach.
void seekRelative(int s) | Przewija o s sekund.
void setEqualizer(int, int, int, int, int, int, int, int, int, int, int) | Ustawia przedziały nasycenia korektora.
void setEqualizerEnabled( bool active ) | Włącza/wyłącza listę odtwarzania.
void setEqualizerPreset( QString name ) | Ustawia zestaw korektora.
void setLyricsByPath( QString url, QString lyrics ) | Ustawia słowa utworu określonego ścieżką dostępu.
void setScore( int score ) | Ustawia punktację aktualnie odtwarzanego utworu.
void setScoreByPath( QString url, int score ) | Ustawia punktacje utworu określonego ścieżką.
void setVolume(int volume) | Ustawia głośność w przedziale 0-100%
void showBrowser( QString browser ) | Pokazuje przeglądarkę w oknie listy odtwarzania.
void showOSD() | Wyświetla OSD na ekranie.
void stop() | Analogicznie do wciśnięcia przycisku "Zatrzymaj".
void transferDeviceFiles() | Przenosi pliki na urządzenie mediów.
void volumeDown() | Zmniejsza głośność o rozsądną wartość.
void volumeUp() | Zwiększa głośność o rozsądną wartość.

### dcop amarok playlist

Funkcja DCOP | Działanie
--- | ---
int getActiveIndex() | Zwraca pozycję aktywnego utworu, -1 jeżeli żaden nie jest aktywny.
int getTotalTrackCount() | Zwraca liczbę utworów na liście odtwarzania, 0 jezeli jest pusta.
QString saveCurrentPlaylist() | Zapisuje biezącą listę odtwarzanai do pliku current.xml i zwraca ścieżkę do niego.
void addMedia( KURL ) | Dodaje medium audio określone adresem url.
void addMediaList( KURL::List ) | Dodaje kilka mediów audio określonych adresem url.
void clearPlaylist() | Opróżnia listę odtwarzania.
void playByIndex(int) | Rozpoczyna odtwarzanie utworu o podanej pozycji.
void playMedia( KURL ) | Dodaje medium audio określone adresem url.
void popupMessage( QString) | Wyświetla tymczasową wiadomość.
void removeCurrentTrack() | Zwraca bieżący utwór z listy odtwarzania.
void repopulate() | Zapełnia listę odtwarzania losowymi utworami.
void saveM3u( QString path, bool relativePaths) | Zapisuje bieżącą listę odtwarzania jako plik m3u.
void setStopAfterCurrent( bool ) | Włącza lub wyłącza opcję "Zatrzymaj po tym utworze".
void shortStatusMessage( QString) | Pokazuje tymczasową wiadomość na pasku stanu,
void shufflePlaylist() | Dokonuje wymieszania listy odtwarzania.
void togglePlaylist() | Włącza/wyłącza okno listy odtwarzania.

### dcop amarok playlistbrowser

Funkcja DCOP | Działanie
--- | ---
void addPodcast( QString ) | Dodaje podcasta do przeglądarki listy odtwarzania.
void scanPodcasts() | Przeszukuje wszystkie podcasty w poszukiwaniu uaktualnień.
void addPlaylist( QString ) | Dodaje listę odtwarzania do przegladarki listy odtwarzania.

### dcop amarok script

Funkcja DCOP | Działanie
--- | ---
bool runScript( QString name) | Uruchamia skrypt o podanej nazwie. Zwraca wartośc true w razie powodzenia.
bool stopScript( QString name) | Zatrzymuje skrypt o podanej nazwie. Zwraca wartośc true w razie powodzenia.
QStringList listRunningScripts() | Zwaraca listę wszystkich aktualnie działających skrpytów.
void addCustomMenuItem(QString submenu, QString itemTitle ) | Uaktywnia i ustawia tytuł własnej pozycji w menu.
void removeCustomMenuItem(QString submenu, QString itemTitle ) | Usuwa własną pozycję z menu.
QString readConfig( QString key) | Zwraca wartość AmarokConfig dla podanego klucza.

## Opcje wiersza poleceń

amaroK obsługuje standardowe funkcje wiersza poleceń Qt oraz kde, posiada także opcje wykorzystywane tylko przez niego samego.

Opcje Qt i kde:

Opcja | Działanie
--- | ---
--help | Wyświetla pomoc na temat opcji.
--help-qt | Wyświetla opcje właściwe QT.
--help-kde | Wyświetla opcje właściwe KDE.
--help-all | Wyświetla wszystkie opcje.
--author | Wyświetla informacje na temat autora.
-v, --version | Pokazuje informacje o wersji.
--license | Wyświetla informacje na temat licencji.

Opcje amaroK:

Opcje &amarok-dopelniacz; są zaprojektowane do korzystania z nich podczas działania programu.

Opcja | Działanie
--- | ---
-r, --previous | Przechodzi do poprzedniego utworu na liście odtwarzania.
-p, --play | Rozpoczyna odtwarzanie bieżącej listy odtwarzania.
-s, --stop | Zatrzymanie odtwarzania.
--pause | Pauzuje odtwarzanie.
-f, --next | Przechodzi do następnego utworu na liście odtwarzania.
-a, --append | Dołącza pliki/adresy URL do listy odtwarzania.
-e, --enqueue | Zobacz append, dostępny na potrzeby wstecznej kompatybilności
--queue | Kolejkuj pliki/adresu URL po aktualnie odtwarzanym utworze.
-m, --toggle-playlist-window | Włącza/wyłącza okno listy odtwarzania.
--wizard | Uruchamia asystenta pierwszego uruchamiania.
--engine "name" | Uruchamia program &amarok-mianownik; z silnikiem o nazwie...

## Pisanie skryptów

Skrypty pozwalają na poszerzenie możliwości &amarok-dopelniacz; bez zmiany głównego kodu. Skrypty przypominają wtyczki, ale zamiast dedykowanej wtyczki API, wykorzystują one do komunikacji interfejs DCOP &amarok-dopelniacz;. Umożliwia to pisanie skryptów w prawie każdym języku programowania, jak np. Ruby, Python lub PHP. Każdy może tworzyć skrypty, nie tylko w klasycznych językach skryptowych, ale również w językach programowania jak C++ lub C. Dodatkowo, &amarok-mianownik; może powiadamiać skrypty o specjalnych zdarzeniach i sprawiać, że będą działać w odpowiedni sposób. Ten system powiadamiania będzie wyjaśniony w dalszej części tej sekcji.

### Powiązania dla języków skryptowych

Możliwe jest tworzenie prostych skryptów, które nie wymagają interakcji z użytkownikiem, można także tworzyć skrypty z przyjaznym interfejsem, które zachowują się jak samodzielne programy. Przy programowaniu interfejsu może być wykorzystane jedno lub więcej powiązań dostarczonych przez KDE, np. RubyQt, biblioteka powiązania dla języka Ruby. Traci to jednak jakąkolwiek wartość, jeśli nie każdy z użytkowników ma zainstalowane wszystkie dostępne powiązania. Jeśli zdecydujesz się na użycie powiązania, wybierz jedno z bardziej rozpowszechnionych (np. RubyQt lub PyQt).

Aby otrzymywana była informacja zwrotna, w sytuacji gdy jakiś skrypt nie działa z powodu brakującej zależności, musisz sprawdzić w skrypcie czy moduł, który chcesz dołączyć rzeczywiście istnieje. Jeśli brak jest zależności, powinieneś wychwycić błąd i wyświetlić okno informacyjne za pomocą programu "kdialog". Dzięki temu użytkownik dowie się, czemu jego skrypt nie działa.

Ten przykład pokazuje jak wychwycić brakującą zależność w języku Ruby:

    begin
           require 'Korundum'
    rescue LoadError
           error = 'Korundum (powiązania KDE dla języka Ruby) z pakietu kdebindings v3.4 są wymagane przez ten skrypt.'
           `kdialog --sorry '#{error}'`
           exit
    end

### Podstawowe informacje o szablonach

&amarok-mianownik; udostępnia szablony skryptów dla wielu języków w katalogu `scripts/templates/`. Możesz użyć tych skryptów jako podstawy Twoich własnych skryptów i poszerzyć je o pożądane funkcje. Przekonasz się, że tworzenie skryptów jest teraz rzeczywiście łatwe. Np. jeśli znasz nieco język Python; stworzenie skryptu nie zajmie Ci wiele czasu.

### Zarządzanie &amarok-narzednik; za pomocą interfejsu DCOP

Poprzez odwołania do niektórych funkcji DCOP, skrypty mogą zarządzać programem amaroK. Najprostrzym sposobem wywołania funkcji DCOP jest użycie linii poleceń "dcop", która jest częścią każdej dystrybucji KDE.

Oto przykład jak zwiększyć głośność:

    dcop amarok player volumeUp

Większość języków skryptowych zezwala na wykonywanie zewnętrznych programów, z funkcją typu exec(). W ten sposób narzędzie "dcop" może być łatwo wywołane. Oto prosty przykład z języka Python:

    import os
     os.system("dcop amarok player volumeDown")

### Powiadomienia

&amarok-mianownik; wysyła powiadomienia do wszystkich uruchomionych skryptów poprzez wprowadzenie napisów do kanału stdin. Skrypt powinien zatem nieustannie monitorować stdin i odpowiednio reagować na każde z możliwych zdarzeń. Skrypty mogą również zignorować każde, nieistotne dla nich zdarzenie.

&amarok-mianownik; wysyła następujące powiadomienia:

    configure
    Nakazuje skryptowi wyświetlenie okna konfiguracyjnego. Skrypt musi obsługiwać
    samodzielnie przechowywanie i wczytywanie opcji konfiguracyjnych. Kiedy skrypt
    jest uruchomiony, amaroK przenosi jego katalog roboczy do katalogu w którym
    powinny być przechowane wszystkie dane.

    engineStateChange:empty|idle|paused|playing
    Sygnalizuje zmianę stanu silnika.

    trackChange
    Sygnalizuje rozpoczęcie nowego utworu. Skrypt może wykorzystać funkcje DCOP do
    zapytań o dalsze informacje o utworze, np o metadane i o długość.

    volumeChangenewVolume
    Sygnalizuje zmianę poziomu głośności. Poziom głośności jest liczbą z
    z zakresu 0-100.

    customMenuClicked:submenu itemTitle paths
    Zwraca ścieżki do wybranych plików listy odtwarzania, po kliknięciu w menu
    kontekstowym listy odtwarzania użytkownika. W celach identyfikacyjnych zwracane są również podmenu i tytuł,
    na wypadek gdyby skrypt oczekiwał licznych powiadomień.
    Aby umieścić element w menu kontekstowym, użyj funkcji DCOP
    'dcop amarok script addCustomMenuItem( submenu itemTitle )'. Aby usunąć element z
    menu kontekstowego, użyj funkcji DCOP
    'dcop amarok script removeCustomMenuItem( submenu itemTitle )'.

### Zakończenie skryptu

Zanim &amarok-mianownik; zostanie zamknięty lub kiedy użytkownik zatrzyma skrypt w menedżerze skryptów, &amarok-mianownik; wysyła do skryptu sygnał SIGTERM. Sygnał może być zatrzymany w celu wykonania prac porządkowych, typu zapisanie danych czy opcji konfiguracyjnych.

### Pakowanie

Menedżer skryptów &amarok-dopelniacz; potrafi instalować paczki skryptów, które użytkownik pobrał z serwera internetowego. Paczki to zwykłe tarball (.tar), opcjonalnie skompresowane za pomocą bzip2 (.bz2). Gorąco zachęcamy do używania nazw takich jak myscriptmyscript.amarokscript.tar.bz2, tak aby użytkownik zidentyfikował paczkę jako skrypt programu amaroK.

&amarok-mianownik; 1.3 zaakceptuje jedynie paczki z rozszerzeniem amarokscript, więc lepiej używać tego rozszerzenia już teraz.

Zawartość tarball musi być zorganizowana w sposób następujący:

    myscript/
       README
       myscript.py (executable)
       somemodule.py
       foo.data
       ...

### Zezwolenia pliku

Główny skrypt musi posiadać zestaw zezwoleń wykonawczych (+x), podczas gdy dodatkowe moduły wczytywane przez skrypt nie powinny być wykonawcze. Aby chronić zezwolenia pliku w tarball, powinieneś użyć tar z -p flag:

    tar -cf myscript.amarokscript.tar -p myscript

&amarok-mianownik; nie będzie w stanie zainstalować skryptu, jeśli zezwolenia nie będą poprawnie ustawione.

### Dystrybucja

Kiedy paczka jest skończona, możesz wysłać ją do www.kde-apps.orgi umieścić odnośnik w &amarok-narzednik; Wiki Scripts Page. Przy wpisach kde-apps powinieneś użyć kategorii &amarok; Scripts.